diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/ssl/Makefile openssl-1.0.1f-rlwekex/ssl/Makefile
--- openssl-1.0.1f/ssl/Makefile	2014-01-06 15:36:06.000000000 +0100
+++ openssl-1.0.1f-rlwekex/ssl/Makefile	2014-10-16 12:38:15.000000000 +0200
@@ -1049,13 +1091,14 @@
 tls_srp.o: ../include/openssl/lhash.h ../include/openssl/obj_mac.h
 tls_srp.o: ../include/openssl/objects.h ../include/openssl/opensslconf.h
 tls_srp.o: ../include/openssl/opensslv.h ../include/openssl/ossl_typ.h
 tls_srp.o: ../include/openssl/pem.h ../include/openssl/pem2.h
 tls_srp.o: ../include/openssl/pkcs7.h ../include/openssl/pqueue.h
-tls_srp.o: ../include/openssl/rand.h ../include/openssl/rsa.h
-tls_srp.o: ../include/openssl/safestack.h ../include/openssl/sha.h
-tls_srp.o: ../include/openssl/srp.h ../include/openssl/srtp.h
-tls_srp.o: ../include/openssl/ssl.h ../include/openssl/ssl2.h
-tls_srp.o: ../include/openssl/ssl23.h ../include/openssl/ssl3.h
-tls_srp.o: ../include/openssl/stack.h ../include/openssl/symhacks.h
-tls_srp.o: ../include/openssl/tls1.h ../include/openssl/x509.h
-tls_srp.o: ../include/openssl/x509_vfy.h ssl_locl.h tls_srp.c
+tls_srp.o: ../include/openssl/rand.h ../include/openssl/rlwekex.h
+tls_srp.o: ../include/openssl/rsa.h ../include/openssl/safestack.h
+tls_srp.o: ../include/openssl/sha.h ../include/openssl/srp.h
+tls_srp.o: ../include/openssl/srtp.h ../include/openssl/ssl.h
+tls_srp.o: ../include/openssl/ssl2.h ../include/openssl/ssl23.h
+tls_srp.o: ../include/openssl/ssl3.h ../include/openssl/stack.h
+tls_srp.o: ../include/openssl/symhacks.h ../include/openssl/tls1.h
+tls_srp.o: ../include/openssl/x509.h ../include/openssl/x509_vfy.h ssl_locl.h
+tls_srp.o: tls_srp.c
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/ssl/s3_clnt.c openssl-1.0.1f-rlwekex/ssl/s3_clnt.c
--- openssl-1.0.1f/ssl/s3_clnt.c	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/ssl/s3_clnt.c	2014-10-16 12:38:15.000000000 +0200
@@ -1279,10 +1279,14 @@
 	BN_CTX *bn_ctx = NULL;
 	EC_POINT *srvr_ecpoint = NULL;
 	int curve_nid = 0;
 	int encoded_pt_len = 0;
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	RLWE_PUB *srvr_rlwepub = NULL;
+	int encoded_rlwepub_len = 0;
+#endif
 
 	/* use same message size as in ssl3_get_certificate_request()
 	 * as ServerKeyExchange message may be skipped */
 	n=s->method->ssl_get_message(s,
 		SSL3_ST_CR_KEY_EXCH_A,
@@ -1333,10 +1337,22 @@
 			{
 			EC_KEY_free(s->session->sess_cert->peer_ecdh_tmp);
 			s->session->sess_cert->peer_ecdh_tmp=NULL;
 			}
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+		if (s->session->sess_cert->peer_rlwepub_tmp)
+			{
+			RLWE_PUB_free(s->session->sess_cert->peer_rlwepub_tmp);
+			s->session->sess_cert->peer_rlwepub_tmp=NULL;
+			}
+		if (s->session->sess_cert->peer_rlwerec_tmp)
+			{
+			RLWE_REC_free(s->session->sess_cert->peer_rlwerec_tmp);
+			s->session->sess_cert->peer_rlwerec_tmp=NULL;
+			}
+#endif
 		}
 	else
 		{
 		s->session->sess_cert=ssl_sess_cert_new();
 		}
@@ -1601,10 +1617,48 @@
 		SSLerr(SSL_F_SSL3_GET_KEY_EXCHANGE,SSL_R_TRIED_TO_USE_UNSUPPORTED_CIPHER);
 		goto f_err;
 		}
 #endif /* !OPENSSL_NO_DH */
 
+#ifndef OPENSSL_NO_RLWEKEX
+	else if ((alg_k & SSL_kRLWE) && !(alg_k & SSL_kEECDH))
+		{
+		/* Get the encoded RLWE public key and reconciliation data */
+		if ((srvr_rlwepub = RLWE_PUB_new()) == NULL)
+			{
+			SSLerr(SSL_F_SSL3_GET_KEY_EXCHANGE,ERR_R_MALLOC_FAILURE);
+			goto err;
+			}
+
+		encoded_rlwepub_len = (p[0] << 8) | p[1];
+		p += 2;
+		n -= 2;
+		if ((encoded_rlwepub_len >= n) ||
+			(o2i_RLWE_PUB(&srvr_rlwepub, p, encoded_rlwepub_len) == NULL))
+			{
+			al=SSL_AD_DECODE_ERROR;
+			SSLerr(SSL_F_SSL3_GET_KEY_EXCHANGE,SSL_R_BAD_RLWE_PUB);
+			goto f_err;
+			}
+
+		n-=encoded_rlwepub_len;
+		p+=encoded_rlwepub_len;
+		param_len = 2 + encoded_rlwepub_len;
+
+		if (0) ;
+#ifndef OPENSSL_NO_RSA
+		else if (alg_a & SSL_aRSA)
+			pkey=X509_get_pubkey(s->session->sess_cert->peer_pkeys[SSL_PKEY_RSA_ENC].x509);
+#endif
+#ifndef OPENSSL_NO_ECDSA
+		else if (alg_a & SSL_aECDSA)
+			pkey=X509_get_pubkey(s->session->sess_cert->peer_pkeys[SSL_PKEY_ECC].x509);
+#endif
+		s->session->sess_cert->peer_rlwepub_tmp=srvr_rlwepub;
+		}
+#endif /* !OPENSSL_NO_RLWEKEX */
+
 #ifndef OPENSSL_NO_ECDH
 	else if (alg_k & SSL_kEECDH)
 		{
 		EC_GROUP *ngroup;
 		const EC_GROUP *group;
@@ -1680,10 +1734,37 @@
 			}
 
 		n-=param_len;
 		p+=encoded_pt_len;
 
+#ifdef OPENSSL_HYBRID_RLWE_ECDHE
+		if (alg_k & SSL_kRLWE) {
+			/* Get the encoded RLWE public key and reconciliation data */
+			if ((srvr_rlwepub = RLWE_PUB_new()) == NULL)
+				{
+				SSLerr(SSL_F_SSL3_GET_KEY_EXCHANGE,ERR_R_MALLOC_FAILURE);
+				goto err;
+				}
+
+			encoded_rlwepub_len = (p[0] << 8) | p[1];
+			p += 2;
+			n -= 2;
+			if ((encoded_rlwepub_len >= n) ||
+				(o2i_RLWE_PUB(&srvr_rlwepub, p, encoded_rlwepub_len) == NULL))
+				{
+				al=SSL_AD_DECODE_ERROR;
+				SSLerr(SSL_F_SSL3_GET_KEY_EXCHANGE,SSL_R_BAD_RLWE_PUB);
+				goto f_err;
+				}
+
+			n-=encoded_rlwepub_len;
+			p+=encoded_rlwepub_len;
+			param_len += 2 + encoded_rlwepub_len;
+			s->session->sess_cert->peer_rlwepub_tmp=srvr_rlwepub;
+		}
+#endif
+
 		/* The ECC/TLS specification does not mention
 		 * the use of DSA to sign ECParameters in the server
 		 * key exchange message. We do support RSA and ECDSA.
 		 */
 		if (0) ;
@@ -1849,10 +1930,13 @@
 	BN_CTX_free(bn_ctx);
 	EC_POINT_free(srvr_ecpoint);
 	if (ecdh != NULL)
 		EC_KEY_free(ecdh);
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	RLWE_PUB_free(srvr_rlwepub);
+#endif
 	EVP_MD_CTX_cleanup(&md_ctx);
 	return(-1);
 	}
 
 int ssl3_get_certificate_request(SSL *s)
@@ -2215,10 +2299,14 @@
 
 int ssl3_send_client_key_exchange(SSL *s)
 	{
 	unsigned char *p,*d;
 	int n;
+#ifdef OPENSSL_HYBRID_RLWE_ECDHE
+	unsigned char *pprime;
+	int nprime;
+#endif
 	unsigned long alg_k;
 #ifndef OPENSSL_NO_RSA
 	unsigned char *q;
 	EVP_PKEY *pkey=NULL;
 #endif
@@ -2231,10 +2319,20 @@
 	EVP_PKEY *srvr_pub_pkey = NULL;
 	unsigned char *encodedPoint = NULL;
 	int encoded_pt_len = 0;
 	BN_CTX * bn_ctx = NULL;
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	RLWE_PAIR *clnt_rlwe = NULL;
+	RLWE_REC *clnt_rlwerec = NULL;
+	const RLWE_PUB *srvr_rlwepub = NULL;
+	unsigned char *encoded_rlwepub = NULL;
+	int encoded_rlwepub_len = 0;
+	unsigned char *encoded_rlwerec = NULL;
+	int encoded_rlwerec_len = 0;
+	RLWE_CTX * rlwe_ctx = NULL;
+#endif
 
 	if (s->state == SSL3_ST_CW_KEY_EXCH_A)
 		{
 		d=(unsigned char *)s->init_buf->data;
 		p= &(d[4]);
@@ -2627,10 +2725,67 @@
 				SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE, 
 				       ERR_R_ECDH_LIB);
 				goto err;
 				}
 
+#ifdef OPENSSL_HYBRID_RLWE_ECDHE
+			if (alg_k & SSL_kRLWE) {
+				srvr_rlwepub = s->session->sess_cert->peer_rlwepub_tmp;
+
+				if (srvr_rlwepub == NULL)
+					{
+					SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE,
+					    ERR_R_INTERNAL_ERROR);
+					goto err;
+					}
+
+				if ((clnt_rlwe=RLWE_PAIR_new()) == NULL) 
+					{
+					SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE,ERR_R_MALLOC_FAILURE);
+					goto err;
+					}
+				if ((clnt_rlwerec=RLWE_REC_new()) == NULL) 
+					{
+					SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE,ERR_R_MALLOC_FAILURE);
+					goto err;
+					}
+
+				if ((rlwe_ctx = RLWE_CTX_new()) == NULL)
+					{
+					SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE,ERR_R_MALLOC_FAILURE);
+					goto err;
+					}
+
+				/* Generate a new RLWE key pair */
+				if (!(RLWE_PAIR_generate_key(clnt_rlwe, rlwe_ctx)))
+					{
+					SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+					goto err;
+					}
+
+				/* use the 'pprime' buffer for the RLWE shared key, but
+				 * make sure to clear it out afterwards
+				 */
+
+				if ((pprime = OPENSSL_malloc(1024)) == NULL) {
+					SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE,ERR_R_MALLOC_FAILURE);
+					goto err;					
+				}
+
+				nprime = RLWEKEX_compute_key_bob(pprime, 1024, clnt_rlwerec, srvr_rlwepub, clnt_rlwe, NULL, rlwe_ctx);
+				if (nprime <= 0)
+					{
+					SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+					goto err;
+					}
+				// FIXME: I have no idea if this is safe, as I don't know how big p is, but let's try it anyway for testing purposes.
+				memcpy(p + n, pprime, nprime);
+				n += nprime;
+				OPENSSL_free(pprime);
+			}
+#endif
+
 			/* generate master key from the result */
 			s->session->master_key_length = s->method->ssl3_enc \
 			    -> generate_master_secret(s, 
 				s->session->master_key,
 				p, n);
@@ -2673,22 +2828,133 @@
 				*p = n; /* length of encoded point */
 				/* Encoded point will be copied here */
 				p += 1; 
 				/* copy the point */
 				memcpy((unsigned char *)p, encodedPoint, n);
+				p += n;
 				/* increment n to account for length field */
 				n += 1; 
 				}
 
+#ifdef OPENSSL_HYBRID_RLWE_ECDHE
+			if (alg_k & SSL_kRLWE) {
+				/* Encode the public key and reconciliation data */
+				encoded_rlwepub_len = i2o_RLWE_PUB(RLWE_PAIR_get_publickey(clnt_rlwe), &encoded_rlwepub);
+				encoded_rlwerec_len = i2o_RLWE_REC(clnt_rlwerec, &encoded_rlwerec);
+
+				p[0] = (encoded_rlwepub_len >> 8) & 0xFF;
+				p[1] =  encoded_rlwepub_len       & 0xFF;
+				p += 2;
+				memcpy((unsigned char *)p, encoded_rlwepub, encoded_rlwepub_len);
+				p += encoded_rlwepub_len;
+
+				p[0] = (encoded_rlwerec_len >> 8) & 0xFF;
+				p[1] =  encoded_rlwerec_len       & 0xFF;
+				p += 2;
+				memcpy((unsigned char *)p, encoded_rlwerec, encoded_rlwerec_len);
+				p += encoded_rlwerec_len;
+
+				n += 4 + encoded_rlwepub_len + encoded_rlwerec_len;
+
+				/* Free allocated memory */
+				RLWE_CTX_free(rlwe_ctx);
+				OPENSSL_free(encoded_rlwepub);
+				OPENSSL_free(encoded_rlwerec);
+				RLWE_PAIR_free(clnt_rlwe);
+				RLWE_REC_free(clnt_rlwerec);
+			}
+#endif
+
 			/* Free allocated memory */
 			BN_CTX_free(bn_ctx);
 			if (encodedPoint != NULL) OPENSSL_free(encodedPoint);
 			if (clnt_ecdh != NULL) 
 				 EC_KEY_free(clnt_ecdh);
 			EVP_PKEY_free(srvr_pub_pkey);
 			}
 #endif /* !OPENSSL_NO_ECDH */
+#ifndef OPENSSL_NO_RLWEKEX
+		else if ((alg_k & SSL_kRLWE) && !(alg_k & SSL_kEECDH))
+			{
+			srvr_rlwepub = s->session->sess_cert->peer_rlwepub_tmp;
+
+			if (srvr_rlwepub == NULL)
+				{
+				SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE,
+				    ERR_R_INTERNAL_ERROR);
+				goto err;
+				}
+
+			if ((clnt_rlwe=RLWE_PAIR_new()) == NULL) 
+				{
+				SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE,ERR_R_MALLOC_FAILURE);
+				goto err;
+				}
+			if ((clnt_rlwerec=RLWE_REC_new()) == NULL) 
+				{
+				SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE,ERR_R_MALLOC_FAILURE);
+				goto err;
+				}
+
+			if ((rlwe_ctx = RLWE_CTX_new()) == NULL)
+				{
+				SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE,ERR_R_MALLOC_FAILURE);
+				goto err;
+				}
+
+			/* Generate a new RLWE key pair */
+			if (!(RLWE_PAIR_generate_key(clnt_rlwe, rlwe_ctx)))
+				{
+				SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+				goto err;
+				}
+
+			/* use the 'p' output buffer for the RLWE shared key, but
+			 * make sure to clear it out afterwards
+			 */
+
+			n = RLWEKEX_compute_key_bob(p, 1024, clnt_rlwerec, srvr_rlwepub, clnt_rlwe, NULL, rlwe_ctx);
+			if (n <= 0)
+				{
+				SSLerr(SSL_F_SSL3_SEND_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+				goto err;
+				}
+
+			/* generate master key from the result */
+			s->session->master_key_length = s->method->ssl3_enc \
+			    -> generate_master_secret(s, 
+				s->session->master_key,
+				p, n);
+
+			memset(p, 0, n); /* clean up */
+
+			/* Encode the public key and reconciliation data */
+			encoded_rlwepub_len = i2o_RLWE_PUB(RLWE_PAIR_get_publickey(clnt_rlwe), &encoded_rlwepub);
+			encoded_rlwerec_len = i2o_RLWE_REC(clnt_rlwerec, &encoded_rlwerec);
+
+			p[0] = (encoded_rlwepub_len >> 8) & 0xFF;
+			p[1] =  encoded_rlwepub_len       & 0xFF;
+			p += 2;
+			memcpy((unsigned char *)p, encoded_rlwepub, encoded_rlwepub_len);
+			p += encoded_rlwepub_len;
+
+			p[0] = (encoded_rlwerec_len >> 8) & 0xFF;
+			p[1] =  encoded_rlwerec_len       & 0xFF;
+			p += 2;
+			memcpy((unsigned char *)p, encoded_rlwerec, encoded_rlwerec_len);
+			p += encoded_rlwerec_len;
+
+			n = 4 + encoded_rlwepub_len + encoded_rlwerec_len;
+
+			/* Free allocated memory */
+			RLWE_CTX_free(rlwe_ctx);
+			OPENSSL_free(encoded_rlwepub);
+			OPENSSL_free(encoded_rlwerec);
+			RLWE_PAIR_free(clnt_rlwe);
+			RLWE_REC_free(clnt_rlwerec);
+			}
+#endif /* !OPENSSL_NO_RLWEKEX */
 		else if (alg_k & SSL_kGOST) 
 			{
 			/* GOST key exchange message creation */
 			EVP_PKEY_CTX *pkey_ctx;
 			X509 *peer_cert; 
@@ -2918,10 +3184,17 @@
 	if (encodedPoint != NULL) OPENSSL_free(encodedPoint);
 	if (clnt_ecdh != NULL) 
 		EC_KEY_free(clnt_ecdh);
 	EVP_PKEY_free(srvr_pub_pkey);
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	RLWE_CTX_free(rlwe_ctx);
+	OPENSSL_free(encoded_rlwepub);
+	OPENSSL_free(encoded_rlwerec);
+	RLWE_PAIR_free(clnt_rlwe);
+	RLWE_REC_free(clnt_rlwerec);
+#endif
 	return(-1);
 	}
 
 int ssl3_send_client_verify(SSL *s)
 	{
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/ssl/s3_lib.c openssl-1.0.1f-rlwekex/ssl/s3_lib.c
--- openssl-1.0.1f/ssl/s3_lib.c	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/ssl/s3_lib.c	2014-10-16 12:38:15.000000000 +0200
@@ -2826,10 +2826,78 @@
 	256,
 	},
 
 #endif /* OPENSSL_NO_ECDH */
 
+#ifndef OPENSSL_NO_RLWEKEX
+	/* Cipher D000 */
+	{
+	1,
+	TLS1_TXT_RLWE_RSA_WITH_AES_128_GCM_SHA256,
+	TLS1_CK_RLWE_RSA_WITH_AES_128_GCM_SHA256,
+	SSL_kRLWE,
+	SSL_aRSA,
+	SSL_AES128GCM,
+	SSL_AEAD,
+	SSL_TLSV1_2,
+	SSL_NOT_EXP|SSL_HIGH,
+	SSL_HANDSHAKE_MAC_SHA256|TLS1_PRF_SHA256,
+	128,
+	128,
+	},
+
+	/* Cipher D001 */
+	{
+	1,
+	TLS1_TXT_RLWE_ECDSA_WITH_AES_128_GCM_SHA256,
+	TLS1_CK_RLWE_ECDSA_WITH_AES_128_GCM_SHA256,
+	SSL_kRLWE,
+	SSL_aECDSA,
+	SSL_AES128GCM,
+	SSL_AEAD,
+	SSL_TLSV1_2,
+	SSL_NOT_EXP|SSL_HIGH,
+	SSL_HANDSHAKE_MAC_SHA256|TLS1_PRF_SHA256,
+	128,
+	128,
+	},
+
+#ifdef OPENSSL_HYBRID_RLWE_ECDHE
+	/* Cipher D002 */
+	{
+	1,
+	TLS1_TXT_RLWE_ECDHE_RSA_WITH_AES_128_GCM_SHA256,
+	TLS1_CK_RLWE_ECDHE_RSA_WITH_AES_128_GCM_SHA256,
+	SSL_kRLWE|SSL_kEECDH,
+	SSL_aRSA,
+	SSL_AES128GCM,
+	SSL_AEAD,
+	SSL_TLSV1_2,
+	SSL_NOT_EXP|SSL_HIGH,
+	SSL_HANDSHAKE_MAC_SHA256|TLS1_PRF_SHA256,
+	128,
+	128,
+	},
+
+	/* Cipher D003 */
+	{
+	1,
+	TLS1_TXT_RLWE_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256,
+	TLS1_CK_RLWE_ECDHE_ECDSA_WITH_AES_128_GCM_SHA256,
+	SSL_kRLWE|SSL_kEECDH,
+	SSL_aECDSA,
+	SSL_AES128GCM,
+	SSL_AEAD,
+	SSL_TLSV1_2,
+	SSL_NOT_EXP|SSL_HIGH,
+	SSL_HANDSHAKE_MAC_SHA256|TLS1_PRF_SHA256,
+	128,
+	128,
+	},
+#endif
+
+#endif
 
 #ifdef TEMP_GOST_TLS
 /* Cipher FF00 */
 	{
 	1,
@@ -2982,10 +3050,14 @@
 #endif
 #ifndef OPENSSL_NO_ECDH
 	if (s->s3->tmp.ecdh != NULL)
 		EC_KEY_free(s->s3->tmp.ecdh);
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	if (s->s3->tmp.rlwe != NULL)
+		RLWE_PAIR_free(s->s3->tmp.rlwe);
+#endif
 
 	if (s->s3->tmp.ca_names != NULL)
 		sk_X509_NAME_pop_free(s->s3->tmp.ca_names,X509_NAME_free);
 	if (s->s3->handshake_buffer) {
 		BIO_free(s->s3->handshake_buffer);
@@ -3035,10 +3107,17 @@
 		{
 		EC_KEY_free(s->s3->tmp.ecdh);
 		s->s3->tmp.ecdh = NULL;
 		}
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	if (s->s3->tmp.rlwe != NULL)
+		{
+		RLWE_PAIR_free(s->s3->tmp.rlwe);
+		s->s3->tmp.rlwe = NULL;
+		}
+#endif
 #ifndef OPENSSL_NO_TLSEXT
 #ifndef OPENSSL_NO_EC
 	s->s3->is_probably_safari = 0;
 #endif /* !OPENSSL_NO_EC */
 #endif /* !OPENSSL_NO_TLSEXT */
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/ssl/s3_srvr.c openssl-1.0.1f-rlwekex/ssl/s3_srvr.c
--- openssl-1.0.1f/ssl/s3_srvr.c	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/ssl/s3_srvr.c	2014-10-16 12:38:15.000000000 +0200
@@ -478,10 +478,11 @@
 			    /* SRP: send ServerKeyExchange */
 			    || (alg_k & SSL_kSRP)
 #endif
 			    || (alg_k & (SSL_kDHr|SSL_kDHd|SSL_kEDH))
 			    || (alg_k & SSL_kEECDH)
+			    || (alg_k & SSL_kRLWE)
 			    || ((alg_k & SSL_kRSA)
 				&& (s->cert->pkeys[SSL_PKEY_RSA_ENC].privatekey == NULL
 				    || (SSL_C_IS_EXPORT(s->s3->tmp.new_cipher)
 					&& EVP_PKEY_size(s->cert->pkeys[SSL_PKEY_RSA_ENC].privatekey)*8 > SSL_C_EXPORT_PKEYLENGTH(s->s3->tmp.new_cipher)
 					)
@@ -905,10 +906,17 @@
 			{
 			EC_KEY_free(s->s3->tmp.ecdh);
 			s->s3->tmp.ecdh = NULL;
 			}
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+		if (s->s3->tmp.rlwe != NULL)
+			{
+			RLWE_PAIR_free(s->s3->tmp.rlwe);
+			s->s3->tmp.rlwe = NULL;
+			}
+#endif
 		s->s3->flags |= SSL3_FLAGS_SGC_RESTART_DONE;
 		return 2;
 		}
 	return 1;
 }
@@ -1563,10 +1571,16 @@
 	unsigned char *encodedPoint = NULL;
 	int encodedlen = 0;
 	int curve_id = 0;
 	BN_CTX *bn_ctx = NULL; 
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	RLWE_PAIR *rlwe=NULL, *rlwep;
+	unsigned char *encoded_rlwepub = NULL;
+	int encoded_rlwepub_len = 0;
+	RLWE_CTX *rlwe_ctx = NULL; 
+#endif
 	EVP_PKEY *pkey;
 	const EVP_MD *md = NULL;
 	unsigned char *p,*d;
 	int al,i;
 	unsigned long type;
@@ -1794,13 +1808,145 @@
 			 */
 			r[0]=NULL;
 			r[1]=NULL;
 			r[2]=NULL;
 			r[3]=NULL;
+
+#ifdef OPENSSL_HYBRID_RLWE_ECDHE
+			if (type & SSL_kRLWE) {
+				rlwep=cert->rlwe_tmp;
+				if (rlwep == NULL)
+					{
+					rlwep=RLWE_PAIR_new();
+					}
+				if (rlwep == NULL)
+					{
+					al=SSL_AD_HANDSHAKE_FAILURE;
+					SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE,SSL_R_MISSING_TMP_ECDH_KEY);
+					goto f_err;
+					}
+
+				if (s->s3->tmp.rlwe != NULL)
+					{
+					SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE, ERR_R_INTERNAL_ERROR);
+					goto err;
+					}
+
+				/* Duplicate the RLWE_PAIR structure. */
+				if (rlwep == NULL)
+					{
+					SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE,ERR_R_RLWE_LIB);
+					goto err;
+					}
+				if ((rlwe = RLWE_PAIR_dup(rlwep)) == NULL)
+					{
+					SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE,ERR_R_RLWE_LIB);
+					goto err;
+					}
+
+				s->s3->tmp.rlwe=rlwe;
+				if ((RLWE_PAIR_get_publickey(rlwe) == NULL) ||
+				    !RLWE_PAIR_has_privatekey(rlwe))
+					{
+					if ((rlwe_ctx = RLWE_CTX_new()) == NULL)
+					    {
+					    SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE,ERR_R_MALLOC_FAILURE);
+					    goto err;
+					    }
+					if(!RLWE_PAIR_generate_key(rlwe, rlwe_ctx))
+					    {
+					    SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE,ERR_R_RLWE_LIB);
+					    goto err;
+					    }
+					   RLWE_CTX_free(rlwe_ctx); rlwe_ctx = NULL;
+					}
+
+				encoded_rlwepub_len = i2o_RLWE_PUB(RLWE_PAIR_get_publickey(rlwe), &encoded_rlwepub);
+
+				if (encoded_rlwepub_len == 0) 
+					{
+					SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE,ERR_R_RLWE_LIB);
+					goto err;
+					}
+
+				n += 2 + encoded_rlwepub_len;
+			}
+#endif
+
 			}
 		else 
 #endif /* !OPENSSL_NO_ECDH */
+#ifndef OPENSSL_NO_RLWEKEX
+			if ((type & SSL_kRLWE) && !(type & SSL_kEECDH))
+			{
+			rlwep=cert->rlwe_tmp;
+			if (rlwep == NULL)
+				{
+				rlwep=RLWE_PAIR_new();
+				}
+			if (rlwep == NULL)
+				{
+				al=SSL_AD_HANDSHAKE_FAILURE;
+				SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE,SSL_R_MISSING_TMP_ECDH_KEY);
+				goto f_err;
+				}
+
+			if (s->s3->tmp.rlwe != NULL)
+				{
+				SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE, ERR_R_INTERNAL_ERROR);
+				goto err;
+				}
+
+			/* Duplicate the RLWE_PAIR structure. */
+			if (rlwep == NULL)
+				{
+				SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE,ERR_R_RLWE_LIB);
+				goto err;
+				}
+			if ((rlwe = RLWE_PAIR_dup(rlwep)) == NULL)
+				{
+				SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE,ERR_R_RLWE_LIB);
+				goto err;
+				}
+
+			s->s3->tmp.rlwe=rlwe;
+			if ((RLWE_PAIR_get_publickey(rlwe) == NULL) ||
+			    !RLWE_PAIR_has_privatekey(rlwe))
+				{
+				if ((rlwe_ctx = RLWE_CTX_new()) == NULL)
+				    {
+				    SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE,ERR_R_MALLOC_FAILURE);
+				    goto err;
+				    }
+				if(!RLWE_PAIR_generate_key(rlwe, rlwe_ctx))
+				    {
+				    SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE,ERR_R_RLWE_LIB);
+				    goto err;
+				    }
+				   RLWE_CTX_free(rlwe_ctx); rlwe_ctx = NULL;
+				}
+
+			encoded_rlwepub_len = i2o_RLWE_PUB(RLWE_PAIR_get_publickey(rlwe), &encoded_rlwepub);
+
+			if (encoded_rlwepub_len == 0) 
+				{
+				SSLerr(SSL_F_SSL3_SEND_SERVER_KEY_EXCHANGE,ERR_R_RLWE_LIB);
+				goto err;
+				}
+
+			n = 2 + encoded_rlwepub_len;
+
+			/* We'll generate the serverKeyExchange message
+			 * explicitly so we can set these to NULLs
+			 */
+			r[0]=NULL;
+			r[1]=NULL;
+			r[2]=NULL;
+			r[3]=NULL;
+			}
+		else 
+#endif /* !OPENSSL_NO_RLWEKEX */
 #ifndef OPENSSL_NO_PSK
 			if (type & SSL_kPSK)
 				{
 				/* reserve size for record length and PSK identity hint*/
 				n+=2+strlen(s->ctx->psk_identity_hint);
@@ -1904,10 +2050,22 @@
 			OPENSSL_free(encodedPoint);
 			encodedPoint = NULL;
 			p += encodedlen;
 			}
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+		if (type & SSL_kRLWE) 
+			{
+			p[0] = (encoded_rlwepub_len >> 8) & 0xFF;
+			p[1] =  encoded_rlwepub_len       & 0xFF;
+			p += 2;
+			memcpy((unsigned char*)p, (unsigned char *)encoded_rlwepub, encoded_rlwepub_len);
+			OPENSSL_free(encoded_rlwepub);
+			encoded_rlwepub = NULL;
+			p += encoded_rlwepub_len;
+			}
+#endif
 
 #ifndef OPENSSL_NO_PSK
 		if (type & SSL_kPSK)
 			{
 			/* copy PSK identity hint */
@@ -2013,10 +2171,14 @@
 err:
 #ifndef OPENSSL_NO_ECDH
 	if (encodedPoint != NULL) OPENSSL_free(encodedPoint);
 	BN_CTX_free(bn_ctx);
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	if (encoded_rlwepub != NULL) OPENSSL_free(encoded_rlwepub);
+	RLWE_CTX_free(rlwe_ctx);
+#endif
 	EVP_MD_CTX_cleanup(&md_ctx);
 	return(-1);
 	}
 
 int ssl3_send_certificate_request(SSL *s)
@@ -2120,10 +2282,14 @@
 	{
 	int i,al,ok;
 	long n;
 	unsigned long alg_k;
 	unsigned char *p;
+#ifdef OPENSSL_HYBRID_RLWE_ECDHE
+	unsigned char *pprime;
+	long nprime;
+#endif
 #ifndef OPENSSL_NO_RSA
 	RSA *rsa=NULL;
 	EVP_PKEY *pkey=NULL;
 #endif
 #ifndef OPENSSL_NO_DH
@@ -2138,10 +2304,18 @@
 	EC_KEY *srvr_ecdh = NULL;
 	EVP_PKEY *clnt_pub_pkey = NULL;
 	EC_POINT *clnt_ecpoint = NULL;
 	BN_CTX *bn_ctx = NULL; 
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	RLWE_PAIR *srvr_rlwe = NULL;
+	RLWE_PUB *clnt_rlwe_pub = NULL;
+	unsigned int clnt_rlwe_pub_len;
+	RLWE_REC *clnt_rlwe_rec = NULL;
+	unsigned int clnt_rlwe_rec_len;
+	RLWE_CTX *rlwe_ctx = NULL; 
+#endif
 
 	n=s->method->ssl_get_message(s,
 		SSL3_ST_SR_KEY_EXCH_A,
 		SSL3_ST_SR_KEY_EXCH_B,
 		SSL3_MT_CLIENT_KEY_EXCHANGE,
@@ -2619,11 +2793,11 @@
 				}
 
 			/* Get encoded point length */
 			i = *p; 
 			p += 1;
-			if (n != 1 + i)
+			if (n < 1 + i)
 				{
 				SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE,
 				    ERR_R_EC_LIB);
 				goto err;
 				}
@@ -2632,16 +2806,72 @@
 				{
 				SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE,
 				    ERR_R_EC_LIB);
 				goto err;
 				}
-			/* p is pointing to somewhere in the buffer
-			 * currently, so set it to the start 
-			 */ 
-			p=(unsigned char *)s->init_buf->data;
+			p += i;
+			n -= 1 + i;
 			}
 
+#ifdef OPENSSL_HYBRID_RLWE_ECDHE
+		if (alg_k & SSL_kRLWE) {
+			if ((rlwe_ctx = RLWE_CTX_new()) == NULL)
+				{
+				SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_MALLOC_FAILURE);
+				goto err;
+				}
+
+			srvr_rlwe = s->s3->tmp.rlwe;
+
+			/* Parse client public key */
+			if (n < 2)
+				{
+				SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+				goto err;
+				}
+			clnt_rlwe_pub_len = (p[0] << 8) | p[1];
+			p += 2;
+			if (n < 2 + clnt_rlwe_pub_len)
+				{
+				SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+				goto err;
+				}
+			if (o2i_RLWE_PUB(&clnt_rlwe_pub, p, clnt_rlwe_pub_len) == 0)
+				{
+				SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+				goto err;
+				}
+			p += clnt_rlwe_pub_len;
+
+			/* Parse client reconciliation */
+			if (n < 2 + clnt_rlwe_pub_len + 2)
+				{
+				SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+				goto err;
+				}
+			clnt_rlwe_rec_len = (p[0] << 8) | p[1];
+			p += 2;
+			if (n < 2 + clnt_rlwe_pub_len + 2 + clnt_rlwe_rec_len)
+				{
+				SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+				goto err;
+				}
+			if (o2i_RLWE_REC(&clnt_rlwe_rec, p, clnt_rlwe_rec_len) == 0)
+				{
+				SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+				goto err;
+				}
+			p += clnt_rlwe_rec_len;
+
+		}
+#endif
+
+		/* p is pointing to somewhere in the buffer
+		 * currently, so set it to the start 
+		 */ 
+		p=(unsigned char *)s->init_buf->data;
+
 		/* Compute the shared pre-master secret */
 		field_size = EC_GROUP_get_degree(group);
 		if (field_size <= 0)
 			{
 			SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, 
@@ -2661,19 +2891,127 @@
 		EC_KEY_free(srvr_ecdh);
 		BN_CTX_free(bn_ctx);
 		EC_KEY_free(s->s3->tmp.ecdh);
 		s->s3->tmp.ecdh = NULL; 
 
+#ifdef OPENSSL_HYBRID_RLWE_ECDHE
+		if (alg_k & SSL_kRLWE) {
+			/* Compute the shared pre-master secret */
+			if ((pprime = OPENSSL_malloc(1024)) == NULL) {
+				SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_MALLOC_FAILURE);
+				goto err;
+			}
+			nprime = RLWEKEX_compute_key_alice(pprime, 1024, clnt_rlwe_pub, clnt_rlwe_rec, srvr_rlwe, NULL, rlwe_ctx);
+			if (nprime <= 0)
+				{
+				SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+				goto err;
+				}
+			RLWE_PUB_free(clnt_rlwe_pub);
+			RLWE_REC_free(clnt_rlwe_rec);
+			RLWE_CTX_free(rlwe_ctx);
+			RLWE_PAIR_free(s->s3->tmp.rlwe);
+			s->s3->tmp.rlwe = NULL; 
+
+			// FIXME: I have no idea if this is safe, as I don't know how big p is, but let's try it anyway for testing purposes.
+			memcpy(p + i, pprime, nprime);
+			i += nprime;
+			OPENSSL_free(pprime);
+		}
+#endif
+
 		/* Compute the master secret */
 		s->session->master_key_length = s->method->ssl3_enc-> \
 		    generate_master_secret(s, s->session->master_key, p, i);
 		
 		OPENSSL_cleanse(p, i);
 		return (ret);
 		}
 	else
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+		if ((alg_k & SSL_kRLWE) && !(alg_k & SSL_kEECDH))
+		{
+		int ret = 1;
+
+		if ((rlwe_ctx = RLWE_CTX_new()) == NULL)
+			{
+			SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_MALLOC_FAILURE);
+			goto err;
+			}
+
+		srvr_rlwe = s->s3->tmp.rlwe;
+
+		/* Parse client public key */
+		if (n < 2)
+			{
+			SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+			goto err;
+			}
+		clnt_rlwe_pub_len = (p[0] << 8) | p[1];
+		p += 2;
+		if (n < 2 + clnt_rlwe_pub_len)
+			{
+			SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+			goto err;
+			}
+		if (o2i_RLWE_PUB(&clnt_rlwe_pub, p, clnt_rlwe_pub_len) == 0)
+			{
+			SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+			goto err;
+			}
+		p += clnt_rlwe_pub_len;
+
+		/* Parse client reconciliation */
+		if (n < 2 + clnt_rlwe_pub_len + 2)
+			{
+			SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+			goto err;
+			}
+		clnt_rlwe_rec_len = (p[0] << 8) | p[1];
+		p += 2;
+		if (n != 2 + clnt_rlwe_pub_len + 2 + clnt_rlwe_rec_len)
+			{
+			SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+			goto err;
+			}
+		if (o2i_RLWE_REC(&clnt_rlwe_rec, p, clnt_rlwe_rec_len) == 0)
+			{
+			SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+			goto err;
+			}
+		p += clnt_rlwe_rec_len;
+
+		/* p is pointing to somewhere in the buffer
+		 * currently, so set it to the start 
+		 */ 
+		p = (unsigned char *)s->init_buf->data;
+
+		/* Compute the shared pre-master secret */
+
+		n = RLWEKEX_compute_key_alice(p, 1024, clnt_rlwe_pub, clnt_rlwe_rec, srvr_rlwe, NULL, rlwe_ctx);
+		if (n <= 0)
+			{
+			SSLerr(SSL_F_SSL3_GET_CLIENT_KEY_EXCHANGE, ERR_R_RLWE_LIB);
+			goto err;
+			}
+
+		RLWE_PUB_free(clnt_rlwe_pub);
+		RLWE_REC_free(clnt_rlwe_rec);
+		RLWE_CTX_free(rlwe_ctx);
+		RLWE_PAIR_free(s->s3->tmp.rlwe);
+		s->s3->tmp.rlwe = NULL; 
+
+		/* Compute the master secret */
+		s->session->master_key_length = s->method->ssl3_enc-> \
+		    generate_master_secret(s, s->session->master_key, p, n);
+		
+		OPENSSL_cleanse(p, n);
+		return (ret);
+		}
+	else
+#endif
 #ifndef OPENSSL_NO_PSK
 		if (alg_k & SSL_kPSK)
 			{
 			unsigned char *t = NULL;
 			unsigned char psk_or_pre_ms[PSK_MAX_PSK_LEN*2+4];
@@ -2886,20 +3224,25 @@
 		}
 
 	return(1);
 f_err:
 	ssl3_send_alert(s,SSL3_AL_FATAL,al);
-#if !defined(OPENSSL_NO_DH) || !defined(OPENSSL_NO_RSA) || !defined(OPENSSL_NO_ECDH) || defined(OPENSSL_NO_SRP)
+#if !defined(OPENSSL_NO_DH) || !defined(OPENSSL_NO_RSA) || !defined(OPENSSL_NO_ECDH) || defined(OPENSSL_NO_SRP) || !defined(OPENSSL_NO_RLWEKEX)
 err:
 #endif
 #ifndef OPENSSL_NO_ECDH
 	EVP_PKEY_free(clnt_pub_pkey);
 	EC_POINT_free(clnt_ecpoint);
 	if (srvr_ecdh != NULL) 
 		EC_KEY_free(srvr_ecdh);
 	BN_CTX_free(bn_ctx);
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+	RLWE_PUB_free(clnt_rlwe_pub);
+	RLWE_REC_free(clnt_rlwe_rec);
+	RLWE_CTX_free(rlwe_ctx);
+#endif
 	return(-1);
 	}
 
 int ssl3_get_cert_verify(SSL *s)
 	{
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/ssl/ssl.h openssl-1.0.1f-rlwekex/ssl/ssl.h
--- openssl-1.0.1f/ssl/ssl.h	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/ssl/ssl.h	2014-10-16 12:38:15.000000000 +0200
@@ -248,10 +248,11 @@
 #define SSL_TXT_kKRB5     	"kKRB5"
 #define SSL_TXT_kECDHr		"kECDHr"
 #define SSL_TXT_kECDHe		"kECDHe"
 #define SSL_TXT_kECDH		"kECDH"
 #define SSL_TXT_kEECDH		"kEECDH"
+#define SSL_TXT_kRLWE		"kRLWE"
 #define SSL_TXT_kPSK            "kPSK"
 #define SSL_TXT_kGOST		"kGOST"
 #define SSL_TXT_kSRP		"kSRP"
 
 #define	SSL_TXT_aRSA		"aRSA"
@@ -272,10 +273,11 @@
 #define SSL_TXT_RSA		"RSA"
 #define SSL_TXT_ECDH		"ECDH"
 #define SSL_TXT_EECDH		"EECDH" /* same as "kEECDH:-AECDH" */
 #define SSL_TXT_AECDH		"AECDH"
 #define SSL_TXT_ECDSA		"ECDSA"
+#define SSL_TXT_RLWE		"RLWE" /* same as "kRLWE" */
 #define SSL_TXT_KRB5      	"KRB5"
 #define SSL_TXT_PSK             "PSK"
 #define SSL_TXT_SRP		"SRP"
 
 #define SSL_TXT_DES		"DES"
@@ -2306,10 +2308,11 @@
 #define SSL_R_BAD_MESSAGE_TYPE				 114
 #define SSL_R_BAD_PACKET_LENGTH				 115
 #define SSL_R_BAD_PROTOCOL_VERSION_NUMBER		 116
 #define SSL_R_BAD_PSK_IDENTITY_HINT_LENGTH		 316
 #define SSL_R_BAD_RESPONSE_ARGUMENT			 117
+#define SSL_R_BAD_RLWE_PUB				 371
 #define SSL_R_BAD_RSA_DECRYPT				 118
 #define SSL_R_BAD_RSA_ENCRYPT				 119
 #define SSL_R_BAD_RSA_E_LENGTH				 120
 #define SSL_R_BAD_RSA_MODULUS_LENGTH			 121
 #define SSL_R_BAD_RSA_SIGNATURE				 122
diff --exclude=.svn --unified=5 --recursive --new-file openssl-1.0.1f/ssl/ssl3.h openssl-1.0.1f-rlwekex/ssl/ssl3.h
--- openssl-1.0.1f/ssl/ssl3.h	2014-01-06 14:47:42.000000000 +0100
+++ openssl-1.0.1f-rlwekex/ssl/ssl3.h	2014-10-16 12:38:15.000000000 +0200
@@ -121,10 +121,13 @@
 #include <openssl/comp.h>
 #endif
 #include <openssl/buffer.h>
 #include <openssl/evp.h>
 #include <openssl/ssl.h>
+#ifndef OPENSSL_NO_RLWEKEX
+#include <openssl/rlwekex.h>
+#endif
 
 #ifdef  __cplusplus
 extern "C" {
 #endif
 
@@ -497,10 +500,13 @@
 #endif
 
 #ifndef OPENSSL_NO_ECDH
 		EC_KEY *ecdh; /* holds short lived ECDH key */
 #endif
+#ifndef OPENSSL_NO_RLWEKEX
+		RLWE_PAIR *rlwe; /* holds short lived RLWE key */
+#endif
 
 		/* used when SSL_ST_FLUSH_DATA is entered */
 		int next_state;			
 
 		int reuse_message;
